import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class FinalBoss here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class FinalBoss extends Enemy
{
    private int magicReloadTime;
    /**
     * Act - do whatever the FinalBoss wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public FinalBoss()
    {
        health(5000);
        turn(-90); //counteract the turn 90 degrees that Enemy has
        setType(FINALBOSS);
    }
    
    public void act() 
    {
        processActions();
        destruction();
    }    
    
    public int getHealth() //returns the health for use in the health bar
    {
        return health;
    }
    
    public void processActions()
    {
        reloadTime--;
        magicReloadTime--;
        if (reloadTime <= 0)
        {
            fire();
            setReloadTime(15);
        }
        if (health <= 2000 && magicReloadTime <= 0) //under half health, new attack
        {
            magicReloadTime = 100;
            targetArea();
        }
    }
    
    public void fire() //fires the shot
    {
        World world = getWorld();
        world.addObject(new FinalBossShot(), this.getX(), this.getY());
    }
    
    public void targetArea() //targets an area for bombing
    {
        World world = getWorld();
        final int TONEDOWNRANGE = 400; //limits the Y range to the bottom half
        int randomCoordX = (int)(Math.random()*world.getWidth());
        int randomCoordY = (int)(Math.random()*(world.getHeight()-TONEDOWNRANGE)+TONEDOWNRANGE);
        world.addObject(new TargetReticle(), randomCoordX, randomCoordY);
    }

    public void destruction() //plays victory if killed
    {
        if (health <= 0)
        {
           World world = getWorld();
           victory();
           world.removeObject(this);
        }
    }
    
    public void victory() //runs if final boss is killed
    {
        World world = getWorld();
            
        world.addObject(new WinningExplosion(),300,200);
        world.addObject(new GameOver("You have defeated the boss." +
                                        "\nCongratulations, you win!"),300,400);
        Greenfoot.playSound("NukeExplosion.mp3");
        Greenfoot.playSound("YouWin.mp3");
        Greenfoot.stop();
    }
}
