import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
/**
 * Write a description of class Ground here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Ground extends World
{
    /**
     * Constructor for objects of class Ground.
     * 
     */
    FinalBoss finalBoss;
    Player player;
    BouncingLaserIndicator bli;
    MissileCount missileCount;
    ScoreBoard scoreBoard;
    private GreenfootSound backGroundMusic;
    private int spawnTimer;
    public Ground()
    {    
        // Create a new world with 600x400 cells with a cell size of 1x1 pixels.
        super(600, 800, 1);
        
        player = new Player();
        
        finalBoss = new FinalBoss();
        
        addObject(player,300,700);

        addObject(new MissileCount(),550,750);
        
        addObject(new MissileText(),500,750);
        
        addObject(new ScoreBoard(),235,750);
        
        addObject(new ScoreText(),125,750);
        
        backGroundMusic = new GreenfootSound("GameMusic.mp3");
        backGroundMusic.setVolume(50);
    }
    
    public void stopped()
    {
        backGroundMusic.pause(); //stops music if paused
    }
 
    public void started()
    {
        backGroundMusic.playLoop(); //plays music if game starts
    }
    
    public void act()
    {
        spawn(); //spawns enemies
        spawnUltraPowerUp(); //random chance to spawn a nuke or a bouncing laser
        gameOver(); //lose if enemy kills player
    }
    
    public void spawn()
    {
        spawnTimer--;
        if (spawnTimer <= 0 && ScoreBoard.getEnemies() > 0)
        {
            spawnEnemies();
        }
        else if (ScoreBoard.getEnemies() <= 0 && ScoreBoard.getEnemies() >= -10)
        {
            addObject(finalBoss,300,150);
            addObject(new HealthBar(),300,300);
            Greenfoot.playSound("SuddenImpact.mp3");
           
            final int CANTSPAWN = 10;
            
            ScoreBoard scoreBoard = scoreBoardIndicator();
            scoreBoard.update(CANTSPAWN); //no more enemies spawn; 0 - 10 = -10
        }
    }
        
    public FinalBoss getFinalBoss()
    {
        return finalBoss;
    }
    
    public Player getPlayer()
    {
        return player;
    }
    
    public BouncingLaserIndicator bli()
    {
        return bli;
    }
    
    public MissileCount missileCountIndicator()
    {
        return missileCount;
    }   
    
    public ScoreBoard scoreBoardIndicator()
    {
        return scoreBoard;
    }
    
    public void spawnEnemies()
    {
        spawnTimer = 40;
        
        final int LEAVELEFTEDGE = 30; //prevents enemies from spawning too close to left edge
        
        int maxX = getWidth()-LEAVELEFTEDGE;
        int randomX = (int)(Math.random()*(maxX-LEAVELEFTEDGE)) + LEAVELEFTEDGE; 
        //spawns between 30 and 540
        int spawnPoint = 50;
        int FiringEnemySpawnY = 50; /*this is to make so the laser that it fires does not 
        instantly get removed because it is "at the edge"*/
        
        final int TOTALNUMBERS = 14; //10 numbers for enemies
        final int UP_TO_FOURTEEN = 1; //adds one to create the range of 1 - 14
        
        int spawnRandomizer = (int)((Math.random()*TOTALNUMBERS)+UP_TO_FOURTEEN);
        if (spawnRandomizer <= RunnerEnemy.getRunnerEnemy())
        {
            addObject(new RunnerEnemy(),randomX,spawnPoint);
        }
        else if (spawnRandomizer > RunnerEnemy.getRunnerEnemy() &&
                 spawnRandomizer <= ExplodingEnemy.getExplodingEnemy())
        {
            addObject(new ExplodingEnemy(),randomX,spawnPoint);
        }
        else if (spawnRandomizer > ExplodingEnemy.getExplodingEnemy() &&
                 spawnRandomizer <= FiringEnemy.getFiringEnemy())
        {
            addObject(new FiringEnemy(),randomX,FiringEnemySpawnY);
        }
        else if (spawnRandomizer == ForceField.getForceField())
        {
            addObject(new ForceField(),randomX,spawnPoint);
        }
        else if (spawnRandomizer == MissileDrop.getMissileDrop())
        {
            addObject(new MissileDrop(),randomX,spawnPoint);
        }
    }
    
    public void spawnUltraPowerUp()
    {
        int luckyNumber = (int)(Math.random()*1000);
        if (luckyNumber == 7 && ScoreBoard.getEnemies() != 0)
        /*every frame there is a 0.1% chance to spawn a nuke.
          if the final boss spawns, no nukes will spawn.*/
        {
            addObject(new Nuke(),300,400);
        }
        else if (luckyNumber == 10 && ScoreBoard.getEnemies() != 0)
        //same thing as above
        {
            addObject(new BouncingLaser(),300,600);
        }
    }
    
    public void gameOver()
    {
        List <Player> detectPlayer = getObjects(Player.class);
        if (detectPlayer.size() == 0)
        {
            int halfWidth = getWidth()/2;
            int halfHeight = getHeight()/2;
            addObject(new GameOver("Game Over.\nYou Died."),halfWidth,halfHeight);
            Greenfoot.playSound("GameOver.mp3");
            stopped(); //stops the background music
            Greenfoot.stop();
        }
    }
}
